NAME
ossctl - Open Sound System device management applet.

DESCRIPTION
This application allows you to select the default audio device for input, 
output and full duplex operations. This application can run in either graphical
mode or in curses mode. When you run the application, you are presented with a
main menu with the following options:
o Save changes and exit
o Cancel changes and exit
o Audio self test
o /dev/dsp input device assignment
o /dev/dsp output device assignment
o /dev/dsp duplex device assignment

For each of the device assignment menu options you will see a list of
devices and four buttons at the bottom of the screen: 
<Move Up> <Move Down> <OK> <Cancel>

The first device in the list is the device that will be opened by the first
application to access /dev/dsp in playback or record or duplex mode. i.e.
if you are changing the /dev/dsp output device assignment, then the first
device in the list will be accessed when the application opens /dev/dsp and
if that device is busy, the second device will be tried and so on.

KNOWN PROBLEMS
o This program is old and not fully compatible with OSS 4.0. Some of it's
functionality is no longer applicaple. A replacement for ossctl will be 
introduced later.
o This manual page is not up to date with the program.

EXAMPLE
The following display will be shown when you select the /dev/dsp output 
assignment menu option:

	/dev/dsp9: OSS Virtual Mixer v2.5 Playback CH#7
	/dev/dsp8: OSS Virtual Mixer v2.5 Playback CH#6
	/dev/dsp7: OSS Virtual Mixer v2.5 Playback CH#5
	/dev/dsp6: OSS Virtual Mixer v2.5 Playback CH#4
	/dev/dsp5: OSS Virtual Mixer v2.5 Playback CH#3
	/dev/dsp4: OSS Virtual Mixer v2.5 Playback CH#2
	/dev/dsp3: OSS Virtual Mixer v2.5 Playback CH#1
	/dev/dsp2: OSS Virtual Mixer v2.5 Playback CH#0
	/dev/dsp0: AMD Athlon64 Audio (MULTICH)(AC3)
	/dev/dsp1: AMD Athlon64 Audio (shadow)(MULTICH)(AC3)

The above example shows that the Virtual Mixer devices /dev/dsp9-/dev/dsp2 
will be opened by default and then the physical devices /dev/dsp0 and /dev/dsp1.

Note that /dev/dsp0 and /dev/dsp1 have some additional information such
as (MULTICH) and (AC3) and (shadow). MULTICH means that the device is capable
of playing 4 or 6 channel audio so if you want your applications to access
the MULTICHANNEL audio by default, move /dev/dsp0 to the first device. If you
system supports AC3 (Dolby Digital) passthrough via SPDIF then you can move 
/dev/dsp0 or /dev/dsp1 to the top and now all apps that access /dev/dsp will 
route their audio to the SPDIF output port.


SPECIAL DEVICES
In addition to ossctl, OSS 3.99 now also automatically creates new devices
called /dev/dsp_ac3 and /dev/dsp_multich that are symlinks to the dsp device
that supports Dolby Digital AC3 and 4.1/5.1/7.1 multi-channel analog output.

When using popular DVD apps you need to specify which device to use 
otherwise the application will default to the Virtual Mixer which
only supports stereo or the default audio device in cases where Virtual
Mixer is disabled.

Configuring common DVD players:

o mplayer 5.1 channel analog output:
  Type: mplayer -ao oss:/dev/dsp_multich -channels 6 dvd://
  You can also add the following lines to ~/.mplayer/config to make it work from the GUI (gmplayer)
  ao=oss:/dev/dsp_multi_ch
  channels=6

o mplayer ac3 output:
  mplayer -ao oss:/dev/dsp_ac3 -ac hwac3

o ogle analog 5.1 output.  
  The following is the revised <audio> .... </audio>
  section of ~/.oglerc. Note that below you set the output for Analog
  output routing.

	<device>
	<driver>oss</driver>
	<path>/dev/dsp_multich</path>
	</device>
	...
	...
	<channel_config>
	<chtype>Left</chtype>
	<chtype>Right</chtype>
	<chtype>RearLeft</chtype>
	<chtype>RearRight</chtype>
	<chtype>Center</chtype>
	<chtype>LFE</chtype>
	</channel_config>
	...
	<channel_config>
	<chtype>AC3</chtype>
	</channel_config>

  If you need to use AC3 passthrough to an external Dolby/DTX decoder,
  set the device path to /dev/dsp_ac3.

o xine:
  You need to first set the AC3 device or Multichannel device using ossctl as 
  the first device. Now start Xine, and from the Configuration panel for Audio,
  you will either See AC3 pass through or 4.1/5.1 channel buttons depending on
  what device is set in ossctl. You will now need to shutdown Xine and restart
  it so that the setting takes into effect.

SEE ALSO
o savemixer(1)
o SNDCTL_SYSINFO(2)
o SNDCTL_AUDIOINFO(2)
o SNDCTL_MIXERINFO(2)
o SNDCTL_MIDIINFO(2)

FILES
/sbin/ossctl	
/usr/lib/oss/etc/dspdevs.map

AUTHOR
4Front Technologies
