#ifndef UART401_H
#define UART401_H
/*
 * Purpose: Definitions for the MPU-401 (UART) support library
 */

/*
 * This file is part of Open Sound System
 *
 * Copyright (C) 4Front Technologies 1996-2007.
 *
 * This software is released under CDDL 1.0 source license for operating systems
 * that have their full source code available under the BSD or CDDL licenses.
 *
 * See the COPYING file included in the main directory of this source
 * distribution. Please contact sales@opensound.com for further info.
 */

/*
 * NOTE! This is not the development version of this file. Please download the
 * sources of the latest Open Sound System version from 
 * http://developer.opensound.com/sources if you plan to make any changes
 * to the software. We may not be able to incorporate changes made to this
 * file back to the official OSS version.
 */

#ifndef MIDI_CORE_H
#include "midi_core.h"
#endif

/*
 * Purpose: Definitions for the MPU-401 UART driver
 */

typedef struct uart401_devc
{
  oss_native_word base;
  int irq;
  oss_device_t *osdev;
  int running;
  oss_mutex_t mutex;
  oss_midi_inputbuf_t save_input_buffer;
  int opened, disabled;
  volatile unsigned char input_byte;
  int my_dev;
  int share_irq;
}
uart401_devc;

extern int uart401_init (uart401_devc * devc, oss_device_t * osdev, int base,
			 char *name);
extern void uart401_irq (uart401_devc * devc);
extern void uart401_disable (uart401_devc * devc);
#endif
